/*
 * Nios definition
 */
#include <u.h>
#include <bio.h>
//#include "/nios/include/ureg.h"
#include <mach.h>

/*
 * No registers for now - disassembly of executable files only.
 */
Reglist niosreglist[] = {
	{  0 }
};

	/* the machine description */
Mach mnios =
{
	"nios",
	MNIOS,		/* machine type */
	niosreglist,	/* register set */
	0,	/* register set size */
	0,		/* fp register set size */
	"PC",		/* name of PC */
	"SP",		/* name of SP */
	"R31",		/* name of link register */
	"setSB",	/* static base register name */
	0,		/* static base register value */
	0x1000,		/* page size */
	0xC0000000ULL,	/* kernel base */
	0xC0000000ULL,	/* kernel text mask */
	0x3FFFFFFFULL,	/* user stack top */
	4,		/* quantization of pc */
	4,		/* szaddr */
	4,		/* szreg */
	4,		/* szfloat */
	8,		/* szdouble */
};
