#include	"l.h"

Optab	optab[] =
{
 /* call	*/	ACALL,		C_NONE,		C_LBRA,		0,	4,	0x00,	0,
 /* jmpi	*/	AJMP,		C_NONE,		C_LBRA,		0,	4,	0x01,	0,
 /* ldb		*/	AMOVB,		C_SOREG,	C_REG,		1,	4,	0x07,	0,
 /* ldbio	*/	AMOVBIO,	C_SOREG,	C_REG,		1,	4,	0x27,	0,
 /* ldbu	*/	AMOVBU,		C_SOREG,	C_REG,		1,	4,	0x03,	0,
 /* ldbuio	*/	AMOVBUIO,	C_SOREG,	C_REG,		1,	4,	0x23,	0,
 /* ldh		*/	AMOVH,		C_SOREG,	C_REG,		1,	4,	0x0F,	0,
 /* ldhio	*/	AMOVHIO,	C_SOREG,	C_REG,		1,	4,	0x2F,	0,
 /* ldhu	*/	AMOVHU,		C_SOREG,	C_REG,		1,	4,	0x0B,	0,
 /* ldhuio	*/	AMOVHUIO,	C_SOREG,	C_REG,		1,	4,	0x2B,	0,
 /* ldw		*/	AMOVW,		C_SOREG,	C_REG,		1,	4,	0x17,	0,
 /* ldwio	*/	AMOVWIO,	C_SOREG,	C_REG,		1,	4,	0x37,	0,
 /*	addi	*/	AMOVW,		C_SACON,	C_REG,		1,	4,	0x04,	0,
 /*	addi	*/	AMOVW,		C_SECON,	C_REG,		1,	4,	0x04,	0,
 /*	addi	*/	AMOVW,		C_SRCON,	C_REG,		1,	4,	0x04,	0,
 /* addi	*/	AADD,		C_ADDCON,	C_REG,		2,	4,	0x04,	0,
 /* andi	*/	AAND,		C_ANDCON,	C_REG,		2,	4,	0x0C,	0,
 /* cmpeqi	*/	ACMPEQ,		C_ADDCON,	C_REG,		2,	4,	0x20,	0,
 /* cmplti	*/	ACMPLT,		C_ADDCON,	C_REG,		2,	4,	0x10,	0,
 /* cmpltui	*/	ACMPLTU,	C_ANDCON,	C_REG,		2,	4,	0x30,	0,
 /* cmpgei	*/	ACMPGE,		C_ADDCON,	C_REG,		2,	4,	0x08,	0,
 /* cmpgeui	*/	ACMPGEU,	C_ANDCON,	C_REG,		2,	4,	0x28,	0,
 /* cmpnei	*/	ACMPNE,		C_ADDCON,	C_REG,		2,	4,	0x18,	0,
 /* muli	*/	AMUL,		C_ADDCON,	C_REG,		2,	4,	0x24,	0,
 /* ori		*/	AOR,		C_ANDCON,	C_REG,		2,	4,	0x14,	0,
 /* xori	*/	AXOR,		C_ANDCON,	C_REG,		2,	4,	0x1C,	0,
 /* stb		*/	AMOVB,		C_REG,		C_SOREG,	3,	4,	0x05,	0,
 /* stbio	*/	AMOVBIO,	C_REG,		C_SOREG,	3,	4,	0x25,	0,
 /* sth		*/	AMOVH,		C_REG,		C_SOREG,	3,	4,	0x0D,	0,
 /* sthio	*/	AMOVHIO,	C_REG,		C_SOREG,	3,	4,	0x2D,	0,
 /* stw		*/	AMOVW,		C_REG,		C_SOREG,	3,	4,	0x15,	0,
 /* stwio	*/	AMOVWIO,	C_REG,		C_SOREG,	3,	4,	0x35,	0,
 /* andhi	*/	AAND,		C_UCON,		C_REG,		4,	4,	0x2C,	0,
 /* orhi	*/	AOR,		C_UCON,		C_REG,		4,	4,	0x34,	0,
 /* xorhi	*/	AXOR,		C_UCON,		C_REG,		4,	4,	0x3C,	0,
 /* or		*/	AOR,		C_LCON,		C_REG,		5,	8,	0x34,	0x14,
 /* xor		*/	AXOR,		C_LCON,		C_REG,		5,	8,	0x3C,	0x1C,
 /* beq		*/	ABEQ,		C_REG,		C_SBRA,		6,	4,	0x26,	0,
 /* bge		*/	ABGE,		C_REG,		C_SBRA,		6,	4,	0x0E,	0,
 /* bgeu	*/	ABGEU,		C_REG,		C_SBRA,		6,	4,	0x2E,	0,
 /* blt		*/	ABLT,		C_REG,		C_SBRA,		6,	4,	0x16,	0,
 /* bltu	*/	ABLTU,		C_REG,		C_SBRA,		6,	4,	0x36,	0,
 /* bne		*/	ABNE,		C_REG,		C_SBRA,		6,	4,	0x1E,	0,
 /* br		*/	ABR,		C_NONE,		C_SBRA,		6,	4,	0x06,	0,
 /* flushd	*/	AFLUSHD,	C_NONE,		C_SOREG,	7,	4,	0x3B,	0,
 /* flushda	*/	AFLUSHDA,	C_NONE,		C_SOREG,	7,	4,	0x1B,	0,
 /* initd	*/	AINITD,		C_NONE,		C_SOREG,	7,	4,	0x33,	0,
 /* initda	*/	AINITDA,	C_NONE,		C_SOREG,	7,	4,	0x13,	0,
 /* rdprs	*/	ARDPRS,		C_ADDCON,	C_REG,		8,	4,	0x38,	0,
 /* custom	*/	ACUSTOM,	C_LCON,		C_LCON,		9,	4,	0x32,	0,
 /* bret	*/	ABRET,		C_NONE,		C_NONE,		10,	4,	0x49,	0x1E00,
 /* eret	*/	AERET,		C_NONE,		C_NONE,		10,	4,	0x41,	0x1D1E,
 /* flushp	*/	AFLUSHP,	C_NONE,		C_NONE,		10,	4,	0x44,	0,
 /* ret		*/	ARET,		C_NONE,		C_NONE,		10,	4,	0x45,	0x1F00,
 /* sync	*/	ASYNC,		C_NONE,		C_NONE,		10,	4,	0x76,	0,
 /* roli	*/	AROL,		C_LCON,		C_REG,		11,	4,	0x42,	0,
 /* slli	*/	ASLL,		C_LCON,		C_REG,		11,	4,	0x52,	0,
 /* srai	*/	ASRA,		C_LCON,		C_REG,		11,	4,	0x7A,	0,
 /* srli	*/	ASRL,		C_LCON,		C_REG,		11,	4,	0x5A,	0,
 /* add		*/	AADD,		C_REG,		C_REG,		12,	4,	0x71,	0,
 /* and		*/	AAND,		C_REG,		C_REG,		12,	4,	0x4E,	0,
 /* div		*/	ADIV,		C_REG,		C_REG,		12,	4,	0x65,	0,
 /* divu	*/	ADIVU,		C_REG,		C_REG,		12,	4,	0x64,	0,
 /* mul		*/	AMUL,		C_REG,		C_REG,		12,	4,	0x67,	0,
 /* mulxss	*/	AMULXSS,	C_REG,		C_REG,		12,	4,	0x5F,	0,
 /* mulxsu	*/	AMULXSU,	C_REG,		C_REG,		12,	4,	0x57,	0,
 /* mulxuu	*/	AMULXUU,	C_REG,		C_REG,		12,	4,	0x47,	0,
 /* nor		*/	ANOR,		C_REG,		C_REG,		12,	4,	0x46,	0,
 /* or		*/	AOR,		C_REG,		C_REG,		12,	4,	0x56,	0,
 /* or		*/	AMOVW,		C_REG,		C_REG,		12,	4,	0x56,	0,
 /* rol		*/	AROL,		C_REG,		C_REG,		12,	4,	0x43,	0,
 /* ror		*/	AROR,		C_REG,		C_REG,		12,	4,	0x4B,	0,
 /* sll		*/	ASLL,		C_REG,		C_REG,		12,	4,	0x53,	0,
 /* sra		*/	ASRA,		C_REG,		C_REG,		12,	4,	0x7B,	0,
 /* srl		*/	ASRL,		C_REG,		C_REG,		12,	4,	0x5B,	0,
 /* sub		*/	ASUB,		C_REG,		C_REG,		12,	4,	0x79,	0,
 /* xor		*/	AXOR,		C_REG,		C_REG,		12,	4,	0x5E,	0,
 /* cmpeq	*/	ACMPEQ,		C_REG,		C_REG,		13,	4,	0x60,	0,
 /* cmpge	*/	ACMPGE,		C_REG,		C_REG,		13,	4,	0x48,	0,
 /* cmpgeu	*/	ACMPGEU,	C_REG,		C_REG,		13,	4,	0x68,	0,
 /* cmplt	*/	ACMPLT,		C_REG,		C_REG,		13,	4,	0x50,	0,
 /* cmpltu	*/	ACMPLTU,	C_REG,		C_REG,		13,	4,	0x70,	0,
 /* cmpne	*/	ACMPNE,		C_REG,		C_REG,		13,	4,	0x58,	0,
 /* callr	*/	ACALL,		C_NONE,		C_ZOREG,		14,	4,	0x5D,	0x1F,
 /* flushi	*/	AFLUSHI,	C_NONE,		C_ZOREG,		14,	4,	0x4C,	0,
 /* initi	*/	AINITI,		C_NONE,		C_ZOREG,		14,	4,	0x69,	0,
 /* jmp		*/	AJMP,		C_NONE,		C_ZOREG,		14,	4,	0x4D,	0,
 /* wrprs	*/	AMOVW,		C_REG,		C_PRSREG,	15,	4,	0x54,	0,
 /* nextpc	*/	ANEXTPC,	C_NONE,		C_REG,		16,	4,	0x5C,	0,
 /* rdctl	*/	AMOVW,		C_CTLREG,	C_REG,		17,	4,	0x66,	0,
 /* break	*/	ABREAK,		C_NONE,		C_LCON,		18,	4,	0x74,	0x1E,
 /* trap	*/	ATRAP,		C_NONE,		C_LCON,		18,	4,	0x6D,	0x1D,
 /* wrctl	*/	AMOVW,		C_REG,		C_CTLREG,	19,	4,	0x6E,	0,
 /* add		*/	AADD,		C_LCON,		C_REG,		20,	12,	0x71,	0,
 /* and		*/	AAND,		C_LCON,		C_REG,		20,	12,	0x4E,	0,
 /* cmpeq	*/	ACMPEQ,		C_LCON,		C_REG,		20,	12,	0x60,	0,
 /* cmpge	*/	ACMPGE,		C_LCON,		C_REG,		20,	12,	0x48,	0,
 /* cmpgeu	*/	ACMPGEU,	C_LCON,		C_REG,		20,	12,	0x68,	0,
 /* cmplt	*/	ACMPLT,		C_LCON,		C_REG,		20,	12,	0x50,	0,
 /* cmpltu	*/	ACMPLTU,	C_LCON,		C_REG,		20,	12,	0x70,	0,
 /* cmpne	*/	ACMPNE,		C_LCON,		C_REG,		20,	12,	0x58,	0,
 /* mul		*/	AMUL,		C_LCON,		C_REG,		20,	12,	0x67,	0,
 /* addi	*/	AMOVW,		C_ADDCON,	C_REG,		21,	4,	0x04,	0,
 /* ori		*/	AMOVW,		C_ANDCON,	C_REG,		21,	4,	0x14,	0,
 /* orhi	*/	AMOVW,		C_UCON,		C_REG,		22,	4,	0x34,	0,
 /* or		*/	AMOVW,		C_LCON,		C_REG,		23,	8,	0x34,	0x14,
 /* srai	*/	AMOVB,		C_REG,		C_REG,		24,	8,	0x7A,	0x52,
 /* srai	*/	AMOVH,		C_REG,		C_REG,		24,	8,	0x7A,	0x52,
 /* andi	*/	AMOVBU,		C_REG,		C_REG,		25,	4,	0x0C,	0,
 /* andi	*/	AMOVHU,		C_REG,		C_REG,		25,	4,	0x0C,	0,
 /* -		*/	ATEXT,		C_LEXT,		C_LCON,		26,	0,	0x00,	0,
 /* -		*/	AXXX,		C_NONE,		C_NONE,		0,	0,	0x00,	0,
};